<template>
  <GameResult
    v-if="showResult"
    :result="result"
    :choice="settings.choice"
    @quit="quit"
    @nextRound="nextRound"
  ></GameResult>
  <GameRestart
    v-if="showRestart"
    @cancel="cancel"
    @restart="restart"
  ></GameRestart>
  <div class="game-board">
    <div class="header">
      <BaseIcon
        class="logo"
        width="72px"
        height="32px"
        color="none"
        iconName="logoIcon"
      />
      <div class="turn-indicator bg-navy text-silver">
        <BaseIcon width="20px" height="20px" color="#A8BFC9" :iconName="icon" />
        <h2 class="uppercase fs-600">turn</h2>
      </div>
      <div class="btn-restart bg-silver" @click="restartGame">
        <BaseIcon
          width="20px"
          height="20px"
          color="#1F3641"
          iconName="restartIcon"
        />
      </div>
    </div>
    <div class="board">
      <div
        v-for="(cell, index) in cells"
        :key="index"
        @click="cell == '' && movePlayer(index)"
        class="cell bg-navy"
        :class="{
          'x-cell': cell == 'X',
          'o-cell': cell == 'O',
          'x-outline': cell == '' && isXTurn,
          'o-outline': cell == '' && !isXTurn,
        }"
      ></div>
    </div>
  </div>
  <GameScore :score="score" :settings="settings" />
</template>

<script>
/* eslint-disable */
import winner from "@/config/winner";
import GameScore from "@/components/GameScore.vue";
import GameResult from "@/components/GameResult.vue";
import GameRestart from "@/components/GameRestart.vue";
import { computed, reactive, onMounted, ref } from "vue";
import { choices } from "@/config";
export default {
  name: "GameBoard",
  props: {
    settings: {
      type: Object,
      required: true,
    },
  },
  components: {
    GameScore,
    GameResult,
    GameRestart,
  },
  setup(props) {
    const cells = ref(["", "", "", "", "", "", "", "", ""]);
    const showResult = ref(false);
    const result = ref(null);
    const score = reactive({ X: 0, O: 0, Ties: 0 });
    const showRestart = ref(false);
    const { settings } = reactive(props);
    const isXTurn = ref(true);
    const icon = computed(() => {
      return isXTurn.value ? "xTurnIcon" : "oTurnIcon";
    });
    let CPU, opponent;
    onMounted(() => {
      makeFirstMoveForCPU();
    });
    function makeFirstMoveForCPU() {
      if (settings.isVsCPU) {
        CPU = settings.choice == choices.X ? "O" : "X";
        opponent = settings.choice == choices.X ? "X" : "O";
        if (settings.choice == choices.O) {
          cells.value[Math.floor(Math.random() * cells.value.length)] = CPU;
          isXTurn.value = settings.choice == choices.O ? false : true;
        }
      }
    }
    function evaluate(board) {
      const winningConditions = [
        [0, 1, 2],
        [0, 3, 6],
        [0, 4, 8],
        [1, 4, 7],
        [2, 5, 8],
        [2, 4, 6],
        [3, 4, 5],
        [6, 7, 8],
      ];
      for (let i = 0; i <= 7; i++) {
        const winCondition = winningConditions[i];
        let a = board[winCondition[0]];
        let b = board[winCondition[1]];
        let c = board[winCondition[2]];
        if (a === "" || b === "" || c === "") {
          continue;
        }
        if (a === b && b === c) {
          return a == CPU ? +10 : -10;
        }
      }
      return 0;
    }
    function checkIfGameFinished(board) {
      const winningConditions = [
        [0, 1, 2],
        [0, 3, 6],
        [0, 4, 8],
        [1, 4, 7],
        [2, 5, 8],
        [2, 4, 6],
        [3, 4, 5],
        [6, 7, 8],
      ];
      for (let i = 0; i <= 7; i++) {
        const winCondition = winningConditions[i];
        let a = board[winCondition[0]];
        let b = board[winCondition[1]];
        let c = board[winCondition[2]];
        if (a === "" || b === "" || c === "") {
          continue;
        }
        if (a === b && b === c) {
          return a == "X" ? winner.X_WIN : winner.O_WIN;
        }
        if (i == 7) {
          return isMovesLeft(board) ? null : winner.TIIED;
        }
      }
    }
    function updateScore() {
      if (result.value != null) {
        if (result.value == winner.O_WIN) {
          ++score.O;
        } else if (result.value == winner.X_WIN) {
          ++score.X;
        } else {
          ++score.Ties;
        }
        showResult.value = true;
      }
    }
    function movePlayer(index) {
      const value = isXTurn.value ? "X" : "O";
      cells.value[index] = value;
      result.value = checkIfGameFinished(cells.value);
      updateScore();
      // isXTurn.value = !isXTurn.value;
      if (settings.isVsCPU) {
        moveCPU();
        result.value = checkIfGameFinished(cells.value);
        updateScore();
        isXTurn.value = settings.choice == choices.O ? false : true;
      } else {
        isXTurn.value = !isXTurn.value;
      }
    }
    function moveCPU() {
      const board = cells.value;
      let bestMove = findBestMove(board);
      cells.value[bestMove] = CPU;
    }
    function isMovesLeft(board) {
      return board.filter((e) => e == "").length == 0 ? false : true;
    }

    function minimax(board, depth, isMax) {
      let score = evaluate(board);

      // If Maximizer has won the game
      // return his/her evaluated score
      if (score == 10) return score;

      // If Minimizer has won the game
      // return his/her evaluated score
      if (score == -10) return score;

      // If there are no more moves and
      // no winner then it is a tie
      if (isMovesLeft(board) == false) return 0;

      // If this maximizer's move
      if (isMax) {
        let best = -1000;

        // Traverse all cells
        for (let i = 0; i < board.length; i++) {
          // Check if cell is empty
          if (board[i] == "") {
            // Make the move
            board[i] = CPU;
            // Call minimax recursively
            // and choose the maximum value
            best = Math.max(best, minimax(board, depth + 1, !isMax));
            // Undo the move
            board[i] = "";
          }
        }
        return best;
      }
      // If this minimizer's move
      else {
        let best = 1000;

        // Traverse all cells
        for (let i = 0; i < board.length; i++) {
          // Check if cell is empty
          if (board[i] == "") {
            // Make the move
            board[i] = opponent;
            // Call minimax recursively and
            // choose the minimum value
            best = Math.min(best, minimax(board, depth + 1, !isMax));
            // Undo the move
            board[i] = "";
          }
        }
        return best;
      }
    }

    function findBestMove(board) {
      let bestVal = -1000;
      let bestMove;
      // Traverse all cells, evaluate
      // minimax function for all empty
      // cells. And return the cell
      // with optimal value.
      for (let i = 0; i < board.length; i++) {
        // Check if cell is empty
        if (board[i] == "") {
          // Make the move
          board[i] = CPU;
          // compute evaluation function
          // for this move.
          let moveVal = minimax(board, 0, false);

          // Undo the move
          board[i] = "";

          // If the value of the current move
          // is more than the best value, then
          // update best
          if (moveVal > bestVal) {
            bestMove = i;
            bestVal = moveVal;
          }
        }
      }
      return bestMove;
    }

    function quit() {
      resetGame();
      settings.isStartGame = false;
    }
    function nextRound() {
      resetGame();
    }
    function resetGame() {
      cells.value = ["", "", "", "", "", "", "", "", ""];
      showResult.value = false;
      isXTurn.value = true;
      makeFirstMoveForCPU();
    }
    function restartGame() {
      showRestart.value = true;
    }
    function restart() {
      resetGame();
      cancel();
    }
    function cancel() {
      showRestart.value = false;
    }

    return {
      icon,
      showResult,
      showRestart,
      isXTurn,
      result,
      cells,
      score,
      movePlayer,
      restartGame,
      quit,
      nextRound,
      restart,
      cancel,
    };
  },
};
</script>

<style lang="scss" scoped>
.game-board {
  .header {
    display: grid;
    grid-template-columns: repeat(3, 1fr);
    gap: 2rem;
    align-items: center;
    .logo {
      justify-self: start;
    }
    .turn-indicator {
      display: flex;
      align-items: center;
      justify-content: space-between;
      box-shadow: inset 0 -4px 0 #10212a;
      gap: 0.9rem;
      border-radius: 10px;
      padding-block: 0.6rem;
      padding-inline: 1.5rem;
    }
    .btn-restart {
      justify-self: end;
      align-items: center;
      border-radius: 5px;
      box-shadow: inset 0 -4px 0 #6b8997;
      display: flex;
      justify-content: center;
      height: 40px;
      width: 40px;
      &:hover {
        background: var(--clr-silver-hover);
        cursor: pointer;
      }
    }
  }
  .board {
    display: grid;
    grid-template-columns: repeat(3, 1fr);
    grid-template-rows: repeat(3, 85px);
    @include respond-to("medium") {
      grid-template-rows: repeat(3, 110px);
    }
    gap: 1.5rem;
    margin-block: 2rem;
    .cell {
      cursor: pointer;
      background-position: center;
      background-repeat: no-repeat;
      background-size: 44px 44px;
      @include respond-to("medium") {
        background-size: 64px 64px;
      }
      border-radius: 10px;
      box-shadow: inset 0 -8px 0 #10212a;
      &.o-cell {
        cursor: auto;
        background-image: url("@/assets/icon-o.svg");
      }
      &.x-cell {
        cursor: auto;
        background-image: url("@/assets/icon-x.svg");
      }
      &.o-outline:hover {
        background-image: url("@/assets/icon-o-outline.svg");
      }
      &.x-outline:hover {
        background-image: url("@/assets/icon-x-outline.svg");
      }
    }
  }
}
</style>
